"use strict";var flottplot=function(){class FlottplotError extends Error{}class ParseError extends FlottplotError{}class ValueError extends FlottplotError{}class ElementError extends FlottplotError{}class FormatError extends FlottplotError{}class ItemsError extends FlottplotError{}class CycleError extends FlottplotError{}function isString(obj){return typeof obj=="string"||obj instanceof String}function isNumber(obj){return Number.isFinite(obj)}function asDate(value){value=value.trim();let matchA=value.match(/^([0-9][0-9][0-9][0-9])[-\/]([01]?[0-9])([-\/]([0-3]?[0-9]))?/);let matchB=value.match(/^(([0-3]?[0-9])[-\/.])?([01]?[0-9])[-\/.]([0-9][0-9][0-9][0-9])/);if(matchA==null&&matchB==null)throw new ParseError("Invalid date specification in '"+value+"'");let year=parseInt(matchA!=null?matchA[1]:matchB[4]);let month=parseInt(matchA!=null?matchA[2]:matchB[3])-1;let day=matchA!=null?matchA[4]!=null?parseInt(matchA[4]):1:matchB[2]!=null?parseInt(matchB[2]):1;value=value.substr((matchA!=null?matchA:matchB)[0].length);let matchC=value.match(/^([ T]([012]?[0-9])(:([0-5]?[0-9])(:([0-5]?[0-9]))?)?)?$/);if(matchC==null)throw new ParseError("Invalid time specification in '"+value+"'");let hours=matchC[2]!=null?parseInt(matchC[2]):0;let minutes=matchC[4]!=null?parseInt(matchC[4]):0;let seconds=matchC[6]!=null?parseInt(matchC[6]):0;return new Date(Date.UTC(year,month,day,hours,minutes,seconds))}function pyformat(value,spec){let match=spec.match(/^(?:(.)?([<>=^]))?([+\- ])?(0)?([1-9][0-9]*)?([sd])?$/);if(match==null){return null}let fill=match[1]==null?match[4]=="0"?"0":" ":match[1];let align=match[2];let sign=match[3];let zerop=match[4]=="0"&&align==null;let width=match[5]==null?0:parseInt(match[5]);let kind=match[6];if(isString(value)&&(kind==null||kind==="s")&&align!=="="&&sign==null){if(align==null){align="<"}if(zerop){zerop=false;fill="0"}sign=""}else if(isNumber(value)&&kind!=="s"){if(align==null){align=">"}if(value<0){sign="-"}else if(sign==="-"||sign==null){sign=""}value=Math.abs(value).toString()}else{return null}if(value.length<width){if(zerop){return sign+value.padStart(width-sign.length,"0")}else if(align===">"){return(sign+value).padStart(width,fill)}else if(align==="<"){return(sign+value).padEnd(width,fill)}else if(align==="^"){value=sign+value;let lwidth=value.length+Math.floor((width-value.length)/2);return value.padStart(lwidth,fill).padEnd(width,fill)}else if(align==="="){let lwidth=value.length+Math.floor((width-value.length)/2);return(sign+value.padStart(lwidth,fill)).padEnd(width,fill)}}return sign+value}let _pystrftime_lookup={d:x=>pyformat(x.getUTCDate(),"0>2"),m:x=>pyformat(x.getUTCMonth()+1,"0>2"),y:x=>pyformat(x.getUTCFullYear()%100,"0>2"),Y:x=>x.getUTCFullYear(),H:x=>pyformat(x.getUTCHours(),"0>2"),M:x=>pyformat(x.getUTCMinutes(),"0>2"),S:x=>pyformat(x.getUTCSeconds(),"0>2"),"%":x=>"%"};function pystrftime(value,spec){let out=[];let pct=false;for(let i=0;i<spec.length;++i){let c=spec.charAt(i);if(pct&&_pystrftime_lookup.hasOwnProperty(c)){out[out.length-1]=_pystrftime_lookup[c](value).toString();pct=false}else{out.push(c);pct=c==="%"}}return out.join("")}class Value{get TEXT(){return new TextValue(this._TEXT!=null?this._TEXT:this)}get _variables(){return new Set}_eval(substitutions){return this}static from(value){if(value==null){return null}if(false){return new TextValue(value)}for(let Cls of[NumberValue,DateDeltaValue,DateValue,TextValue]){try{return new Cls(value)}catch(error){if(!(error instanceof ParseError)){throw error}}}throw new ParseError}}class TextValue extends Value{constructor(value){super();if(value==null)throw new ParseError("...");this._value=value.toString()}toString(spec){if(spec==null){return this._value}let aspy=pyformat(this._value,spec);if(aspy!=null){return aspy}throw new FormatError("invalid specification '"+spec+"' for text value '"+this._value+"'")}_add(other){if(other instanceof TextValue){return new TextValue(this._value+other._value)}}_slice(other){if(other instanceof NumberValue){return new TextValue(this._value.slice(0,other._value))}}_rslice(other){if(other instanceof NumberValue){return new TextValue(this._value.slice(other._value))}}_eq(other){if(other instanceof TextValue){return this._value==other._value}}}class NumberValue extends Value{constructor(value){super();if(isNumber(value)){this._value=Math.trunc(value)}else if(isString(value)&&!isNaN(value)&&!isNaN(parseInt(value))){this._value=parseInt(value);this._TEXT=value}else{throw new ParseError}}toString(spec){if(spec==null){return this._value.toString()}let aspy=pyformat(this._value,spec);if(aspy!=null){return aspy}throw new FormatError("invalid specification '"+spec+"' for number value "+this._value)}_pos(){return new NumberValue(+this._value)}_neg(){return new NumberValue(-this._value)}_mul(other){if(other instanceof NumberValue){return new NumberValue(this._value*other._value)}}_div(other){if(other instanceof NumberValue){return new NumberValue(this._value/other._value)}}_mod(other){if(other instanceof NumberValue){return new NumberValue(this._value%other._value)}}_add(other){if(other instanceof NumberValue){return new NumberValue(this._value+other._value)}}_sub(other){if(other instanceof NumberValue){return new NumberValue(this._value-other._value)}}_gt(other){if(other instanceof NumberValue){return this._value>other._value}}_lt(other){if(other instanceof NumberValue){return this._value<other._value}}_ge(other){if(other instanceof NumberValue){return this._value>=other._value}}_le(other){if(other instanceof NumberValue){return this._value<=other._value}}_eq(other){if(other instanceof NumberValue){return this._value==other._value}}}class DateValue extends Value{constructor(value){super();if(isString(value)){this._value=asDate(value);this._TEXT=value}else{this._value=new Date(value)}this.YEAR=new NumberValue(this._value.getUTCFullYear());this.MONTH=new NumberValue(this._value.getUTCMonth()+1);this.DAY=new NumberValue(this._value.getDate());this.HOUR=new NumberValue(this._value.getUTCHours());this.MINUTE=new NumberValue(this._value.getUTCMinutes());this.SECOND=new NumberValue(this._value.getUTCSeconds())}toString(spec){let aspy=pystrftime(this._value,spec!=null?spec:"%Y-%m-%d %H:%M:%S");if(aspy!=null){return aspy}throw new FormatError("invalid specification '"+spec+"' for date value "+this._value)}_add(other){if(other instanceof DateDeltaValue){return new DateValue(this._value.getTime()+1e3*other._value)}}_radd(other){return this._add(other)}_sub(other){if(other instanceof DateDeltaValue){return new DateValue(this._value.getTime()-1e3*other._value)}else if(other instanceof DateValue){let milliseconds=this._value.getTime()-other._value.getTime();return new DateDeltaValue(milliseconds/1e3)}}_eq(other){if(other instanceof DateValue){return this._value===other._value}}}class DateDeltaValue extends Value{constructor(value){super();if(isString(value)){let match=value.match(/^\s*((?:[+\-]?)(?:(?:[1-9][0-9]*)|0))([smhd])\s*$/);if(match==null)throw new ParseError("TODO");if(match[2]==="d"){this._value=parseInt(match[1])*86400}else if(match[2]==="h"){this._value=parseInt(match[1])*3600}else if(match[2]==="m"){this._value=parseInt(match[1])*60}else if(match[2]==="s"){this._value=parseInt(match[1])}else throw new ParseError("TODO");this._TEXT=value}else if(isNumber(value)){this._value=Math.trunc(value)}else throw new ParseError("TODO");let sign=Math.sign(this._value);let days=Math.trunc(Math.abs(this._value)/86400);let hours=Math.trunc(Math.abs(this._value)%86400/3600);let minutes=Math.trunc(Math.abs(this._value)%3600/60);let seconds=Math.trunc(Math.abs(this._value)%60);this.SIGN=new NumberValue(sign);this.DAYS=new NumberValue(days);this.HOURS=new NumberValue(hours);this.MINUTES=new NumberValue(minutes);this.SECONDS=new NumberValue(seconds);this.TOTAL_SECONDS=new NumberValue(this._value)}toString(spec){if(spec!=null)throw new FormatError("invalid specification '"+spec+"' for date delta value '"+this.toString()+"'");return(this.SIGN._value<0?"-":"+")+this.DAYS.toString()+"d "+this.HOURS.toString("0>2")+":"+this.MINUTES.toString("0>2")+":"+this.SECONDS.toString("0>2")}_pos(){return new DateDeltaValue(+this._value)}_neg(){return new DateDeltaValue(-this._value)}_mul(other){if(other instanceof NumberValue){return new DateDeltaValue(this._value*other._value)}}_rmul(other){return this._mul(other)}_div(other){if(other instanceof NumberValue){return new DateDeltaValue(this._value/other._value)}else if(other instanceof DateDeltaValue){return new NumberValue(this._value/other._value)}}_add(other){if(other instanceof DateDeltaValue){return new DateDeltaValue(this._value+other._value)}}_sub(other){if(other instanceof DateDeltaValue){return new DateDeltaValue(this._value-other._value)}}_eq(other){if(other instanceof DateDeltaValue){return this._value===other._value}}}class AttributeValue extends Value{constructor(name){super();this._name=name.toString();if(this._name.startsWith("_"))throw new ValueError("access to underscore-attribute '"+this._name+"' denied")}toString(spec){if(spec!=null)throw new FormatError("sdjfjasdf");return this._name}_rattr(other){let out=other[this._name];if(out instanceof Value){return out}else throw new ValueError("attribute '"+this._name+"' does not exist on '"+other.toString()+"'")}}class Placeholder{constructor(name){this._name=name.toString()}get _variables(){return new Set([this._name])}_eval(substitutions){let value=substitutions.get(this._name);if(value==null)throw new ValueError("12345");if(!(value instanceof Value))throw new ValueError("23456");return value}toString(){return this._name}}class TokenStream{constructor(text){this._text=text;this._pattern=/\s*(([1-9][0-9]*[smhd])|([1-9][0-9]*)|[().*%+\-§\/]|[A-Za-z_][A-Za-z0-9_]*)\s*/gy;this.advance()}get token(){return this._token}advance(){if(this._pattern.lastIndex===this._text.length){this._token=null}else{let lastIndex=this._pattern.lastIndex;let match=this._pattern.exec(this._text);if(match==null){throw new ParseError("invalid syntax: '"+this._text.slice(lastIndex)+"'")}else if(match[2]!=null){this._token=new DateDeltaValue(match[1])}else if(match[3]!=null){this._token=new NumberValue(match[1])}else{this._token=match[1]}}}}class PrecedenceClimbingParser{constructor(operators){this._uOp=new Map;this._bOp=new Map;for(let op of operators){(op.associativity===0?this._uOp:this._bOp).set(op.symbol,op)}}parse(stream){let ast=this._expr(stream,0);if(stream.token!=null)throw new ParseError("invalid syntax: expected end but got '"+stream.token+"'");return ast}_expr(stream,minPrecedence){let left=this._atom(stream);while(true){let op=this._bOp.get(stream.token);if(stream.token==null||op==null||op.precedence<minPrecedence){break}stream.advance();let right=this._expr(stream,op.precedence+(op.associativity<0?1:0));left=new Expression(op,[left,right])}return left}_atom(stream){let token=stream.token;if(token==null)throw new ParseError("unexpected end");stream.advance();let op=this._uOp.get(token);if(op!=null){return new Expression(op,[this._expr(stream,op.precedence)])}else if(token==="("){let inner=this._expr(stream,0);if(stream.token!==")")throw new ParseError("expected closing parenthesis, got '"+stream.token+"'");stream.advance();return inner}else{return token}}}let _exprParser=new PrecedenceClimbingParser([{symbol:".",precedence:90,associativity:-1,method:"attr"},{symbol:"+",precedence:70,associativity:0,method:"pos"},{symbol:"-",precedence:70,associativity:0,method:"neg"},{symbol:"§",precedence:50,associativity:-1,method:"slice"},{symbol:"*",precedence:40,associativity:-1,method:"mul"},{symbol:"/",precedence:40,associativity:-1,method:"div"},{symbol:"%",precedence:40,associativity:-1,method:"mod"},{symbol:"+",precedence:30,associativity:-1,method:"add"},{symbol:"-",precedence:30,associativity:-1,method:"sub"}]);class Expression{constructor(op,args){this._op=op;this._args=args;if(op.associativity===0&&args.length!==1)throw new ParseError("unary operator '"+op.method+"' ("+op.symbol+") got "+args.length+" arguments");if(op.associativity!==0&&args.length!==2)throw new ParseError("binary operator '"+op.method+"' ("+op.symbol+") got "+args.length+" arguments");if(this._op.method==="attr"){if(!isString(this._args[1]))throw new Error("invalid attribute access in expression '"+this.toString()+"'");this._args[1]=new AttributeValue(this._args[1])}this._args=this._args.map(arg=>{return isString(arg)?new Placeholder(arg):arg})}static parse(text){let expr=_exprParser.parse(new TokenStream(text));return isString(expr)?new Placeholder(expr):expr}get _variables(){let deps=new Set;for(let arg of this._args){if(isString(arg)){deps.add(arg)}else{for(let dep of arg._variables){deps.add(dep)}}}return new Set(deps)}_eval(substitutions){if(substitutions==null){substitutions=new Map}let args=this._args.map(arg=>arg._eval(substitutions));let fop=args[0]["_"+this._op.method];if(fop!=null){let value=fop.call(args[0],args[1]);if(value!=null){return value}}if(args.length>1){let rop=args[1]["_r"+this._op.method];if(rop!=null){let value=rop.call(args[1],args[0]);if(value!=null){return value}}}throw new ValueError("operator '"+this._op.method+"' not defined for "+args.map(_=>_.constructor.name).join(" and "))}toString(){return this._op.symbol+"("+this._args.map(_=>_.toString()).join(", ")+")"}}class UpdateGraph{constructor(){this._nodes=new Set;this._edges=new Map;this._sorted=null}getNode(obj){let node=obj.toString();if(!this._nodes.has(node)){this._nodes.add(node);this._edges.set(node,new Set)}return node}assertNode(obj){let node=obj.toString();if(!this._nodes.has(node))throw new Error("'"+node+"' is not a node of the graph");return node}addEdge(obj,objDep){let node=this.getNode(obj);let nodeDep=this.getNode(objDep);this._edges.get(nodeDep).add(node);this._sorted=null}orderOf(obj){let node=this.assertNode(obj);let order=this._order;return order.get(node)}updateOrderedNodesOf(obj){let node=this.assertNode(obj);let order=this._order;return this._dfs(node).sort(function(x,y){return order.get(x)-order.get(y)})}get orderedNodes(){let order=this._order;return Array.from(this._nodes).sort(function(x,y){return order.get(x)-order.get(y)})}get _order(){if(this._sorted==null){let edges=this._edges;let permanent=new Set;let temporary=new Set;function visit(n){if(permanent.has(n))return;if(temporary.has(n)){let cycle=Array.from(temporary);cycle.slice(cycle.indexOf(n));cycle.push(n);throw new CycleError(cycle)}temporary.add(n);edges.get(n).forEach(visit);temporary.delete(n);permanent.add(n)}this._nodes.forEach(visit);this._sorted=new Map;let i=permanent.size;for(let node of permanent){this._sorted.set(node,i--)}}return this._sorted}_dfs(init){let out=[];let visited=new Set;let stack=[init];while(stack.length>0){let current=stack.pop();if(visited.has(current))continue;out.push(current);visited.add(current);let targets=this._edges.get(current);if(targets!=null){for(let target of targets){stack.push(target)}}}return out}}class FPElement{constructor(id){if(id==null||id==""){this._generateID()}else if(/^[A-Za-z][A-Za-z0-9_]*$/.test(id)){this.id=id}else throw new ElementError("invalid id '"+id+"' for "+this.constructor.name+" (names must begin with A-z and only contain A-z, 0-9 and _)");this.flottplot=null;this.patterns=new Map;this.dependencies=new Set;this.actions=new Set;this._errorBox=null}_generateID(){let pool="qwertzuiopasdfghjklyxcvbnmQWERTZUIOPASDFGHJKLYXCVBNM";let chars=[];for(let i=0;i<30;++i){chars.push(pool.charAt(Math.floor(Math.random()*pool.length)))}this.id="_"+chars.join("")}fail(message){this.failWith(new ElementError("in "+this.constructor.name+" '"+this.id+"': "+message))}failWith(error){if(this.node!=null){if(this._errorBox==null){this._errorBox=dom.newNode("div",{class:"fp-error",style:"position:absolute;top:-3px;left:100%;min-width:250px;max-width:500px;border:3px solid #F00;background-color:#FCC;padding:3px;"});let wrapperDisplay=window.getComputedStyle(this.node).display;let wrapper=dom.newNode("div",{style:"position:relative;padding:0;margin:0;display:"+wrapperDisplay+";border:3px solid #F00;"});this.node.replaceWith(wrapper);wrapper.appendChild(this._errorBox);wrapper.appendChild(this.node)}this._errorBox.appendChild(dom.newNode("div",{},[dom.newNode("b",{},[error.constructor.name,": "]),error.message]));while(this._errorBox.children.length>5){this._errorBox.firstChild.remove()}}else{throw error}}invoke(action,...args){if(!this.actions.has(action)){this.fail("action '"+action+"' does not exist")}else{this[action](...args);this.notify()}}notify(){if(this.flottplot!=null){this.flottplot.notify(this.id)}}initialize(substitution){this.update(substitution)}update(substitution){}setDependenciesFrom(...templates){this.patterns=new Map;this.dependencies=new Set;for(let template of templates){for(let match of template.matchAll(/{.+?}/g)){let pattern=match[0];let[expression,format]=pattern.slice(1,-1).split(":");expression=Expression.parse(expression);this.patterns.set(pattern,[expression,format]);for(let name of expression._variables){this.dependencies.add(name)}}}}substitute(template,substitution){let out=[];let i=0;while(i<template.length){let match=false;for(let[pattern,value]of substitution){if(template.slice(i,i+pattern.length)===pattern){out.push(value);i+=pattern.length;match=true;break}}if(!match){out.push(template.charAt(i));i+=1}}return out.join("")}}class Items{constructor(){this.wrapMin=false;this.wrapMax=false}get wrap(){return this.wrapMax||this.wrapMin}set wrap(wrap){this.wrapMax=wrap==="true"||wrap==="both"||wrap==="max";this.wrapMin=wrap==="true"||wrap==="both"||wrap==="min"}get size(){return this.indexMax-this.indexMin+1}get isFinite(){return isFinite(this.size)}prev(){if(this._selected>this.indexMin){this._selected-=1}else if(this.wrapMin){this._selected=this.indexMax;return Items.WRAP}}next(){if(this._selected<this.indexMax){this._selected+=1}else if(this.wrapMax){this._selected=this.indexMin;return Items.WRAP}}}Items.WRAP="WRAP";class OptionsItems extends Items{constructor(options,init,wrap){super();this._options=Array.from(options);this.wrap=wrap;this.indexMin=0;this.indexMax=this._options.length-1;if(this.size===0)throw new ItemsError("no options specified");this.value=init!=null?init:this._options[0]}get index(){return this._selected}set index(index){if(index<this.indexMin||this.indexMax<index)throw new ItemsError("invalid index "+index+" (out of range)");this._selected=index}get value(){return this._options[this._selected]}set value(value){let index=this._options.findIndex(_=>_._eq(value));if(index<0)throw new ItemsError("value "+value.toString()+" not found in options");this._selected=this.indexMin+index}map(...args){return Array.from(this._options).map(...args)}}class RangeItems extends Items{constructor(init,step,min,max,wrap){super();this.wrap=wrap;if(init!=null){this._offset=init}else if(min!=null){this._offset=min}else if(max!=null){this._offset=max}else throw new ItemsError("range requires specification of at least one of init, min or max");if(step==null)throw new ItemsError("no step specified");this._factor=step;this.indexMin=min==null?Number.NEGATIVE_INFINITY:Math.ceil(min._sub(this._offset)._div(step)._value);this.indexMax=max==null?Number.POSITIVE_INFINITY:Math.floor(max._sub(this._offset)._div(step)._value);if(this.wrap&&!this.isFinite)throw new ItemsError("open-ended range cannot wrap");this.value=this._offset}_genValue(index){return this._offset._add(this._factor._mul(new NumberValue(index)))}_genIndex(value){return Math.round(value._sub(this._offset)._div(this._factor)._value)}get index(){return this._selected}set index(index){if(index<this.indexMin||this.indexMax<index)throw new ItemsError("cannot set to index "+index);this._selected=index}get value(){return this._genValue(this.index)}set value(value){this.index=Math.max(this.indexMin,Math.min(this._genIndex(value),this.indexMax))}map(...args){if(!this.isFinite)throw new ItemsError("cannot list an infinite range");let out=[];for(let index=this.indexMin;index<=this.indexMax;index++){out.push(this._genValue(index))}return out.map(...args)}}let dom={newNode:function(tag,attrs,children){let node=document.createElement(tag);dom.setAttrs(node,attrs);if(children!=null){for(let child of children){node.appendChild(isString(child)?document.createTextNode(child):child)}}return node},newButton:function(attrs,label,f){if(typeof label==="string"){label=[label]}let node=dom.newNode("button",attrs,label);node.addEventListener("click",f);return node},setAttrs:function(node,attrs){if(node==null||attrs==null){return}else if(attrs instanceof dom.Attributes){attrs.assignTo(node)}else{for(let name in attrs){node.setAttribute(name,attrs[name])}}},Attributes:class{constructor(){this._attrs=new Map}set(attr,value){this._attrs.set(attr,value);return this}get(attr,fallback,asType){let value=this._attrs.has(attr)?this._attrs.get(attr):fallback;switch(asType){case"VALUE":return Value.from(value);case"ACTION":return value==null?[]:value.split(";").map(call=>call.split("."));case"TARGET":return value==null?[]:value.split(";")}return value}pop(attr,fallback,asType){const value=this.get(attr,fallback,asType);this._attrs.delete(attr);return value}popActions(names){const out=new Map;for(let name of names){let calls=this.pop(name+"-action",null,"ACTION");if(calls!=null){out.set(name,calls)}}return out}assignTo(node){for(let[attr,value]of this._attrs){node.setAttribute(attr,value)}}get id(){return this.get("id")}static from(node){const out=new dom.Attributes;for(let attr of node.attributes){out.set(attr.name,attr.value)}return out}}};class FPItems extends FPElement{constructor(id,items,format,calls){super(id);this.items=items;this.format=format;this.actions.add("prev");this.actions.add("next");this.actions.add("reset");this._reset_index=this.items.index;this.calls=calls!=null?calls:new Map}get value(){return this.items.value}assertFinite(){if(!this.items.isFinite){return this.fail("list of items is not finite")}}get state(){return this.items.index}set state(state){this.items.index=state}prev(){let e=this.items.prev();if(e===Items.WRAP){this.flottplot.invokeAll(this.calls.get("min-wrap"))}}next(){let e=this.items.next();if(e===Items.WRAP){this.flottplot.invokeAll(this.calls.get("max-wrap"))}}reset(){this.items.index=this._reset_index}static ofType(etype,eid,items,format,calls){switch(etype){case"counter":return new FPCounter(eid,items,format,calls);case"slider":return new FPSlider(eid,items,format,calls);case"dropdown":return new FPDropdown(eid,items,format,calls);case"radio":return new FPRadio(eid,items,format,calls)}throw new ElementError("unknown items type '"+etype+"'")}}class FPCounter extends FPItems{constructor(id,range,format,calls){super(id,range,format,calls);this.box=dom.newNode("input",{type:"text"});this.box.disabled=true;this.node=dom.newNode("span",{class:"fp-range fp-range-counter"},[dom.newButton({},"<",()=>this.invoke("prev")),this.box,dom.newButton({},">",()=>this.invoke("next"))])}update(){this.box.value=this.items.value.toString(this.format)}}class FPDropdown extends FPItems{constructor(id,options,format,calls){super(id,options,format,calls);this.assertFinite();this.node=dom.newNode("select",{class:"fp-select fp-dropdown"},this.items.map((value,i)=>{let label=value.toString(format);let index=this.items.indexMin+i;return dom.newNode("option",{value:index},[label])}));this.node.addEventListener("change",()=>{this.items.index=parseInt(this.node.value);this.notify()})}update(){this.node.value=this.items.index}}class FPRadio extends FPItems{constructor(id,options,format,calls){super(id,options,format,calls);this.assertFinite();this.radios=this.items.map((_,i)=>{let index=this.items.indexMin+i;let radio=dom.newNode("input",{type:"radio",name:id});radio.checked=this.items.index===i;radio.addEventListener("change",()=>{this.items.index=index;this.notify()});return radio});this.node=dom.newNode("span",{class:"fp-select fp-radio"},this.items.map((value,i)=>{let radio=this.radios[i];let label=value.toString(format);return dom.newNode("label",{},[radio,label])}))}update(){this.radios[this.items.index-this.items.indexMin].checked=true}}class FPSlider extends FPItems{constructor(id,range,format,calls){super(id,range,format,calls);this.assertFinite();this.node=dom.newNode("input",{type:"range",min:range.indexMin,max:range.indexMax,step:1,class:"fp-range fp-range-slider"});this.node.addEventListener("input",()=>{this.items.index=parseInt(this.node.value);this.notify()})}update(){this.node.value=this.items.index}}class FPAnimation extends FPElement{constructor(id,targets,attrs){super(id);this.targets=targets;this.dependencies=new Set(targets);this.speed=4;this.timeout=null;this.toggleButton=dom.newButton({},"▶️",()=>this.invoke("toggle"));this.node=dom.newNode("span",attrs,[dom.newButton({},"⏪",()=>this.invoke("slower")),dom.newButton({},"⏹️",()=>this.invoke("reset")),this.toggleButton,dom.newButton({},"⏩",()=>this.invoke("faster"))]);this.node.id=this.id;this.actions.add("reset");this.actions.add("start");this.actions.add("stop");this.actions.add("toggle");this.actions.add("slower");this.actions.add("faster")}invokeAll(action){for(let target of this.targets){this.flottplot.invoke(target,action)}}trigger(){this.invokeAll(this.speed>=0?"next":"prev");this.timeout=setTimeout(()=>this.trigger(),2e3/Math.abs(this.speed))}reset(){this.stop();this.invokeAll("reset")}start(){if(this.timeout==null){this.toggle()}}stop(){if(this.timeout!=null){this.toggle()}}toggle(){if(this.timeout==null){this.toggleButton.textContent="⏸️";this.trigger()}else{this.toggleButton.textContent="▶️";this.timeout=clearTimeout(this.timeout)}}slower(){this.speed-=1+(this.speed===1)}faster(){this.speed+=1+(this.speed===-1)}static from(node){let attrs=dom.Attributes.from(node);return new FPAnimation(attrs.id,attrs.pop("target",null,"TARGET"),attrs)}}class FPBind extends FPElement{constructor(key,calls){super();this.key=key;this.calls=calls}initialize(){for(let[target,action]of this.calls){this.flottplot.bindKey(this.key,target,action)}}static from(node){let attrs=dom.Attributes.from(node);return new FPBind(attrs.pop("key"),attrs.pop("action",null,"ACTION"))}}class FPButton extends FPElement{constructor(id,label,calls,attrs){super(id);this.node=dom.newButton(attrs,label,()=>this.invoke("trigger"));this.calls=calls;this.dependencies=new Set(calls.map(_=>_[0]));this.actions.add("trigger")}trigger(){this.flottplot.invokeAll(this.calls)}static from(node){let attrs=dom.Attributes.from(node);return new FPButton(attrs.id,Array.from(node.childNodes),attrs.pop("action",null,"ACTION"),attrs)}}function getPageRect(node){let rect=node.getBoundingClientRect();return{x:window.pageXOffset+rect.left,y:window.pageYOffset+rect.top,w:rect.width,h:rect.height}}class FPCursors extends FPElement{constructor(id,cursors,attrs){super(id);this.cursors=cursors;for(let cc of this.cursors){if(cc["cursor"]==="hidden")continue;cc.node=dom.newNode("div");if(cc["class"]!=null)cc.node.setAttribute("class",cc["class"]);if(cc["style"]!=null)cc.node.setAttribute("style",cc["style"]);cc.node.style.position="absolute"}this.node=dom.newNode("div",attrs,this.cursors.map(_=>_.node).filter(_=>_!=null));this.node.id=this.id;this.node.className="fp-cursors"}initialize(){for(let cursor of this.cursors){let origin=this.flottplot.getElement(cursor.target);origin.node.addEventListener("mouseover",event=>this.cursors.forEach(cc=>{if(cc.target!==cursor.target&&cc.node!=null){cc.node.style.display="block"}}));origin.node.addEventListener("mousemove",event=>{let etr=getPageRect(event.target);let x=(event.pageX-etr.x)/etr.w;let y=(event.pageY-etr.y)/etr.h;for(let cc of this.cursors){let target=this.flottplot.getElement(cc.target);if(origin.id===target.id||cc.node==null)continue;let style=cc.node.style;let ctr=getPageRect(target.node);if(cc.cursor==="hline"){style.top=ctr.y+y*ctr.h+"px";style.left=ctr.x+"px";style.width=ctr.w+"px"}else if(cc.cursor==="vline"){style.top=ctr.y+"px";style.left=ctr.x+x*ctr.w+"px";style.height=ctr.h+"px"}else if(cc.cursor==="pointer"){style.top=ctr.y+y*ctr.h+"px";style.left=ctr.x+x*ctr.w+"px"}}});origin.node.addEventListener("mouseout",event=>this.cursors.forEach(cc=>{if(cc.node!=null){cc.node.style.display="none"}}))}}static from(node){let cursors=[];for(let child of node.childNodes){if(child.nodeType!==Node.ELEMENT_NODE)continue;let attrs=dom.Attributes.from(child);let cur=attrs.pop("cursor","pointer");cursors.push({target:attrs.pop("target"),cursor:cur,style:attrs.pop("style"),class:attrs.pop("class","fp-cursor fp-"+cur)})}return new FPCursors(node.id,cursors,dom.Attributes.from(node))}}class FPOverlay extends FPElement{constructor(id,attrs){super(id);this.inner=dom.newNode("div",{class:"fp-overlay-inner"});this.node=dom.newNode("div",attrs,[this.inner]);this.node.id=this.id;this.node.className="fp-overlay";this.node.style.display="none";this.node.addEventListener("click",event=>this.hide());this.actions.add("show");this.actions.add("hide");this.actions.add("toggle")}initialize(){this.flottplot.overlay=this}put(content){this.inner.replaceChildren(content);this.show()}show(){if(this.inner.childNodes.length!==0){this.node.style.display="flex"}}hide(){this.node.style.display="none"}toggle(){if(this.node.style.display==="none"){this.show()}else{this.hide()}}static from(node){return new FPOverlay(node.id,dom.Attributes.from(node))}}class FPPlot extends FPElement{constructor(id,src,attrs){super(id);this.node=dom.newNode("img",attrs);this.node.id=this.id;this.node.src=src;this.overlay=dom.newNode("img");this.node.addEventListener("click",()=>{if(this.flottplot.overlay!=null)this.flottplot.overlay.put(this.overlay)});if(src==null){return this.fail("must provide source (src) of plot")}this.src=src;this.setDependenciesFrom(src)}get value(){return Value.from(this.node.src)}update(substitution){let src=this.substitute(this.src,substitution);this.node.src=src;this.overlay.src=src}static from(node){let attrs=dom.Attributes.from(node);return new FPPlot(attrs.id,attrs.pop("src"),attrs)}}class FPRange{static from(node){let attrs=dom.Attributes.from(node);let rng=new RangeItems(attrs.pop("init",null,"VALUE"),attrs.pop("step",null,"VALUE"),attrs.pop("min",null,"VALUE"),attrs.pop("max",null,"VALUE"),attrs.pop("wrap"));return FPItems.ofType(attrs.pop("type","counter"),attrs.id,rng,attrs.pop("format"),attrs.popActions(["min-wrap","max-wrap"]))}}class FPSelect{static from(node){let attrs=dom.Attributes.from(node);let values=[];for(let child of node.childNodes){if(child.nodeType!==Node.ELEMENT_NODE)continue;let value=Value.from(child.textContent);for(let attr of child.attributes){value[attr.name]=Value.from(attr.value)}values.push(value)}let options=new OptionsItems(values,attrs.pop("init",null,"VALUE"),attrs.pop("wrap"));return FPItems.ofType(attrs.pop("type","dropdown"),attrs.id,options,attrs.pop("format"),attrs.popActions(["min-wrap","max-wrap"]))}}class FPStack extends FPElement{constructor(id,plots,attrs){super(id);this.plots=plots;this.node=dom.newNode("div",attrs,this.plots);this.node.id=this.id;this.node.className="fp-stack";this.overlay=dom.newNode("div",{class:"fp-stack"});this.node.addEventListener("click",event=>{if(this.flottplot.overlay!=null){this.flottplot.overlay.put(this.overlay);event.stopPropagation()}},true)}initialize(){for(let plot of this.plots){let overlay=dom.newNode("img",{src:plot.src});try{overlay=this.flottplot.getElement(plot.id).overlay}catch{}this.overlay.appendChild(overlay)}}static from(node){let plots=[];for(let child of node.childNodes){if(child.nodeType!==Node.ELEMENT_NODE)continue;if(child.nodeName!=="IMG")throw new flottplot.ElementError("invalid element '"+child.nodeName+"' in stack");plots.push(child)}return new FPStack(node.id,plots,dom.Attributes.from(node))}}class FPState extends FPElement{initialize(){this.flottplot.urlstate=true}static from(node){return new FPState(node.id)}}class FPText extends FPElement{constructor(id,text){super(id);this.node=dom.newNode("span",{id:id});this.text=text;this.setDependenciesFrom(text)}update(subst){let text=this.substitute(this.text,subst);this.node.textContent=text}static from(node){return new FPText(node.id,node.textContent)}}class FPVideo extends FPElement{constructor(id,sources,attrs){super(id);this.node=dom.newNode("video",attrs,sources.map(src=>dom.newNode("source",{src:src})));this.node.id=this.id;this.actions.add("reset");this.actions.add("play");this.actions.add("pause");this.actions.add("toggle")}reset(){this.pause();this.node.currentTime=0}play(){this.node.play()}pause(){this.node.pause()}toggle(){if(this.node.paused){this.play()}else{this.pause()}}static from(node){let attrs=dom.Attributes.from(node);return new FPVideo(attrs.id,[attrs.pop("src")],attrs)}}class Flottplot{constructor(){this._elements=new Map;this._graph=new UpdateGraph;this.overlay=null;this.bindings=new Map;this.urlstate=false}getElement(target){let element=this._elements.get(target);if(element==null)throw new ElementError("element with id '"+target+"' does not exist");return element}convert(original){let tag=Flottplot.tags.get(original.nodeName);if(tag==null)throw new ElementError("unable to convert '"+original.nodeName+"': no corresponding flottplot element found");let element;try{element=tag.Class.from(original)}catch(error){if(!(error instanceof FlottplotError)){throw error}original.replaceWith(dom.newNode("div",{style:"border:3px solid #F00;background-color:#FCC;padding:3px;"},[dom.newNode("b",{},[error.constructor.name,": "]),error.message]));console.error(error);return}if(element.node==null){original.remove()}else{original.replaceWith(element.node)}if(this._elements.has(element.id)){element.fail("duplicate id");this._elements.get(element.id).fail("duplicate id")}this._elements.set(element.id,element);this._graph.getNode(element.id);for(let dep of element.dependencies){this._graph.addEdge(element.id,dep)}element.flottplot=this;return this}scan(root){let tag=Flottplot.tags.get(root.nodeName);if(tag==null||tag.isRecursive){let children=Array.from(root.childNodes);for(let child of children){this.scan(child)}}if(tag!=null){this.convert(root)}return this}initialize(){for(let id of this._graph.orderedNodes){let element=this._elements.get(id);if(element==null){console.warn("flottplot element with id '"+id+"' does not exist");continue}try{element.initialize(this._substitutionFor(element))}catch(error){element.failWith(error);console.error(error)}}if(this.urlstate){let hash=window.location.hash.substring(1);if(hash.length!==0){this._state=JSON.parse(window.atob(hash))}}}notify(source){for(let target of this._graph.updateOrderedNodesOf(source)){let element=this._elements.get(target);element.update(this._substitutionFor(element))}if(this.urlstate){window.location.hash=window.btoa(JSON.stringify(this._state))}}_substitutionFor(element){let values=new Map;for(let dep of element.dependencies){let dep_element=this._elements.get(dep);if(dep_element==null){element.fail("could not find an element with id '"+dep+"'");return}values.set(dep,dep_element.value)}let out=new Map;for(let[pattern,[expression,format]]of element.patterns){out.set(pattern,expression._eval(values).toString(format))}return out}invoke(target,action){let element=this._elements.get(target);if(element==null)throw new ElementError("element '"+target+"' does not exist");element.invoke(action)}invokeAll(calls){if(calls==null)return;for(let[target,action]of calls){this.invoke(target,action)}}bindKey(key,target,action){if(this.bindings.size===0){document.addEventListener("keydown",event=>this._interceptKey(event))}this.bindings.set(key,()=>this.invoke(target,action))}_interceptKey(event){if(event.target!==document.body||event.ctrlKey||event.altKey){return}let callable=this.bindings.get(event.key);if(callable!=null){callable()}}get _state(){let out={};for(let[id,element]of this._elements){if(id.startsWith("_"))continue;let state=element.state;if(state===undefined)continue;out[id]=state}return out}set _state(state){for(let id of this._graph.orderedNodes){if(!state.hasOwnProperty(id))continue;let element=this._elements.get(id);element.state=state[id];element.update(this._substitutionFor(element));element.notify()}}static registerTag(tag,element,recursive){Flottplot.tags.set(tag.toUpperCase(),{Class:element,isRecursive:recursive})}}Flottplot.tags=new Map;Flottplot.registerTag("fp-animation",FPAnimation,false);Flottplot.registerTag("fp-bind",FPBind,false);Flottplot.registerTag("fp-button",FPButton,false);Flottplot.registerTag("fp-cursors",FPCursors,false);Flottplot.registerTag("fp-overlay",FPOverlay,false);Flottplot.registerTag("fp-plot",FPPlot,false);Flottplot.registerTag("fp-range",FPRange,false);Flottplot.registerTag("fp-select",FPSelect,false);Flottplot.registerTag("fp-stack",FPStack,true);Flottplot.registerTag("fp-state",FPState,false);Flottplot.registerTag("fp-text",FPText,true);Flottplot.registerTag("fp-video",FPVideo,false);return{__version__:"2.1.0",Flottplot:Flottplot,FPElement:FPElement,Value:Value,OptionsItems:OptionsItems,RangeItems:RangeItems,FlottplotError:FlottplotError,ElementError:ElementError,dom:dom}}();
